;; -*- lexical-binding: t -*-

(require 'cl-lib)

(defconst flag-mel-ad-run-replacement 'mel-ad-run-replacement)
(defconst flag-mel-ad-run-original    'mel-ad-run-original)

(defun mel-function-replacement-advice (symbol replacement &optional pred)
  ;; To do: Factor out the advice fun
  (cl-callf or pred (lambda () t))
  (unless (functionp replacement)
    (warn "mel-replace-function: Unknown function: `%s'.
Can't check for interactive form for replacement of `%s'.
Please use `with-eval-after-load' or something like that."
          replacement symbol))
  ;; The hard part is getting commands work as expected.
  ;; We make the interactive spec return an additional flag indicating whether
  ;; the body should run the replacement or the original definition
  (cl-with-gensyms (test-result origfun args old-spec)
    (defvar byte-compile-docstring-max-column)
    (let ((byte-compile-docstring-max-column 999999))
      (byte-compile
       `(lambda (,origfun &rest ,args)
          ,(format "Replace with `%s' via `mel-replace-function'."
                   (if (symbolp replacement)
                       (symbol-name replacement)
                     "an anonymous function"))
          ,@(and (commandp replacement)
                 `((interactive
                    (lambda (,old-spec)
                      (let ((,test-result (funcall #',pred)))
                        (cons
                         (if ,test-result ',flag-mel-ad-run-replacement ',flag-mel-ad-run-original)
                         (advice-eval-interactive-spec
                          (if ,test-result
                              ',(cadr (interactive-form replacement))
                            ,old-spec))))))))
          (if (if (not (memq (car-safe ,args) '(,flag-mel-ad-run-replacement ,flag-mel-ad-run-original)))
                  (funcall #',pred)
                (eq (pop ,args) ',flag-mel-ad-run-replacement))
              (cl-letf (((symbol-function ',symbol) ,origfun))
                (apply #',replacement ,args))
            (apply ,origfun ,args)))))))

(defun test () 1)

(defvar my-ad (mel-function-replacement-advice #'test #'ignore (lambda () t)))
